#include <stdio.h>
#include <time.h>
#include <stdlib.h>


typedef unsigned int uint;
typedef unsigned long long ullong;


void echange(uint *t,uint i,uint j){

    uint tmp;
    tmp=t[i];
    t[i]=t[j];
    t[j]=tmp;
}

uint *GenPerm(uint n){

    uint *t;
    uint indice;
    t=calloc(n,sizeof(uint));

    for(int i=0;i<n;i++){
        t[i]=i+1;
    }

    for(int j=0;j<n;j++){

        indice=(rand()+j)%(n-j);
        echange(t,indice,j);
    }


    return(t);
}

uint *GenPermParm(uint n, float r){

    float p=r*n;
    uint *t;
    uint indice;
    t=calloc(n,sizeof(uint));

    for(int i=0;i<n;i++){
        t[i]=i+1;
    }

    for(int j=0;j<p;j++){

        indice=(rand()+j)%(n-j);
        echange(t,indice,j);
    }


    return(t);
}

uint *CopierPerm(uint *perm , uint n){

    uint *copie;
    copie=calloc(n,sizeof(uint));

    for(int i=0;i<n;i++){

        copie[i]=perm[i];
    }

    return(copie);
}

uint verif_tri(uint *perm , uint n){


    for(int i = 0; i<n-1 ; i++){

        if (perm[i]>perm[i+1]){
            return(0);
        }
    }
    return(1);
}

uint idxmin(uint *perm , uint a , uint b, ullong *nb_cmp){

    uint indice=a;

    for(int i=a+1 ; i<=b ; i++){

        if (perm[i] < perm[indice] ){
            indice=i;
        }
        nb_cmp[0]+=1;
    }
    return(indice);

}

ullong tri_selection(uint *perm , uint n){

    ullong nb_cmp[1]={0};
    uint indice;

    for(int i=0 ; i < (n-1) ; i++){

        indice=idxmin(perm,i,n-1,nb_cmp);
        echange(perm,i,indice);
    }

    return(nb_cmp[0]);

}

ullong tri_bulles(uint *perm , uint n){

    ullong nb_cmp=0;
    int est_trie;

    for (int i= (n-1) ; i > 0 ; i--){

        est_trie=1;

        for (int j=0 ; j < i ; j++ ){

            if (perm[j] > perm[j+1]){

                echange(perm,j,j+1);
                est_trie=0;
            }
            nb_cmp+=1;
        }
        if (est_trie){
            break;
        }
    }

    return (nb_cmp);
}

ullong tri_insertion(uint *perm , uint n){

    ullong nb_cmp=1;

    for(int i=1 ; i<n ; i++){

        for(int j=i ; ((j>0) && (perm[j]<perm[j-1])) ;j-- ){

            echange(perm,j,j-1);
            nb_cmp+=1;
        }
    }

    return(nb_cmp);
}

int main(int argc, char *argv[]) {

    srand(time(NULL));

    uint *t,*t2,*t3;
    uint n=atoi(argv[1]);

    t=GenPermParm(n,0.0001);
    t2=CopierPerm(t,n);
    t3=CopierPerm(t,n);


    printf("%u \t%llu \t%llu \t %llu \n",n ,tri_selection(t,n),tri_bulles(t2,n),tri_insertion(t3,n) );

/*    printf("%u\n",verif_tri(t,n));

    printf("%llu\n",tri_bulles(t2,n));

    printf("%u\n",verif_tri(t2,n));

    printf("%llu\n",tri_insertion(t3,n));

    printf("%u\n",verif_tri(t3,n)); */

    free(t);free(t2);free(t3);

    return 0;
}
